.TH IceDock 1

.de EX          \"Begin example
.ne 5
.if n .sp 1
.if t .sp .5
.nf
.in +5n
..
.de EE          \"End example
.fi
.in -5n
.if n .sp 1
.if t .sp .5
..

.SH NAME
icedock - Dockapp support for different window managers

.SH SYNOPSIS
.B icedock
[-grad_from \fIcolor\fP] [-grad_to \fIcolor\fP]
[-color \fIcolor\fP] [-placement \fIpspec\fP] [-layout \fIlspec\fP]
[-width \fIpixels\fP] [-height \fIpixels\fP] [-handle_width \fIpixels\fP]
[-bevel_width \fIpixels\fP] [-border_width \fIpixels\fP] [-black_border]
[-half_gradient] [-ontop] [-nokill] [-managed] [-verbose] [-wheel]
[-gradient \fIgspec\fP] [-delay \fImilliseconds\fP]
[-tile \fIpath\fP] [-help]

.SH DESCRIPTION

The
.I icedock
program is a panel for WindowMaker, AfterStep dock applications.

.PP
All the command line options(plus
.I client
and
.I order\fP)
can be used in
.I $HOME/.icedockrc\fP.
Dash should be removed and '=' added for options that require argument.
.IP "\fBclient\fP\ = \fIcommand\fP"
Notifies
.I icedock
to invoke this
.I command
on startup.
.IP "\fBorder\fP\ = \fIwspec\fP"
Sets the order for window with
.I wspec
(window class(as per xprop output)).

.SH MOUSE ACTIONS

.IP "\fBPress 3rd button\fP"
inside panel handle. Cursor will change to crosshair,
select some window(point and click), if this window is dockable
it will be swallowed.
.IP "\fBPress mod1 + 3rd button\fP"
same as the above, but
.I ANY
window will be swallowed, regardless of "dockability".
.IP "\fBPress ctrl + 3rd button\fP"
inside panel handle to automatically swallow all present dockable windows.
.IP "\fBPress 2nd button\fP"
anywhere inside panel to quit
.I icedock\fP.
.IP "\fBPress 1st button and move mouse\fP"
inside panel handle to drag panel.
.IP "\fBPress mod1 + 1st button and move mouse\fP"
inside dockapp window to drag it around. You can drag it out of panel
and on mouse release it will be returned to window manager.
.IP "\fBPress and hold 1st button\fP"
inside panel handle for
.I delay
milliseconds(default 100) to minimize panel.

.SH OPTIONS
.PP
The various options are as follows:
.IP \fB-help\fP
Print a usage message and exit.
.IP "\fB-grad_from\fP \fIcolor\fP"
Set gradient starting color, either symbolic name(i.e. red) or rgb value(i.e #ff0000).
.IP "\fB-grad_to\fP \fIcolor\fP"
Set gradient ending color.
.IP "\fB-color\fP \fIcolor\fP"
Set solid background color.
.IP "\fB-placement\fP \fIpspec\fP"
Set placement, one of:
.I TopLeft
.I TopCenter
.I TopRight
.I LeftCenter
.I RightCenter
.I BottomLeft
.I BottomRight
.I BottomCenter
.IP "\fB-layout\fP \fIlspec\fP"
Set layout, either
.I vertical
or
.I horizontal
(Can be abbreviated).
.IP "\fB-width\fP \fIpixels\fP"
Set minimal panel width.
.IP "\fB-height\fP \fIpixels\fP"
Set minimal panel height.
.IP "\fB-handle_width\fP \fIpixels\fP"
Set panel handle width(or height depending on layout).
.IP "\fB-bevel_width\fP \fIpixels\fP"
Set bevel width.
.IP "\fB-border_width\fP \fIpixels\fP"
Set border width.
.IP "\fB-black_border\fP"
Set black border.
.IP "\fB-half_gradient\fP"
Make gradient reach it's maximum at the center of panel.
.IP "\fB-ontop\fP"
Make panel stay ontop.
.IP "\fB-nokill\fP"
Do not kill clients from
.I .icedockrc
on exit.
.IP "\fB-managed\fP"
Allow the window manager to manage panel window, following can be put into
.I $HOME/.icewm/winoptions:
.EX
icedock.ignoreTaskBar: 1
icedock.noFocusOnAppRaise: 1
icedock.ignoreQuickSwitch: 1
icedock.ignoreWinList: 1
icedock.allWorkspaces: 1
icedock.doNotCover: 1
.EE
When this mode is on, window manager is responsible for drawing
the border and it might look not so good.
.IP "\fB-tile\fP \fIpath\fP"
Path to background tile XPM(preferably 64x64). If gradient or color
was set before tile in
.I .icedockrc
or via command line it will be used to draw handle.
.IP "\fB-verbose\fP"
Set verbose flag.
.IP "\fB-wheel\fP"
Use wheel to restack dock apps.
.IP "\fB-gradient\fP \fIgspec\fP"
Set gradient type, either
.I vertical
or
.I horizontal
(Can be abbreviated).
.IP "\fB-delay\fP \fImilliseconds\fP"
Set hide delay(i.e. time when mouse button should be pressed inside panel handle).

.SH AUTHOR
malc@pulsesoft.com
